<script lang="ts">
  import { startTouch, moveTouch } from "$lib/tidy/utils/touchGesture";
  import { sessionStore } from "$lib/local/stores/session.store";
  import { IntervalBarContext } from "$lib/local/types/session.type";
  import { appStore } from "$lib/tidy/stores/app.store";
  import view from "$lib/tidy/stores/view.store";
  import { Size } from "$lib/tidy/types/size.enum";
  import SessionTimeText from "../elements/sessionTimeText/SessionTimeText.svelte";
  import ControlBar from "../elements/controls/ControlBar.svelte";
  import FocusItemList from "../elements/focusitem/FocusItemList.svelte";
  import IntervalBar from "../elements/intervalbar/IntervalBar.svelte";
  import FocusItemsHeading from "./FocusItemsHeading.svelte";
  import TimeleftIndicator from "./timeleftindicator/TimeleftIndicator.svelte";
  import { SessionType } from "$lib/local/components/logs/log.type";
  import { bgClass } from "$lib/tidy/utils/theme.utils";
  import Button from "$lib/tidy/elements/button/Button.svelte";
  import { AppSkin } from "$lib/tidy/types/appearance.type";
  import Divider from "$lib/tidy/elements/Divider.svelte";
  import { Orientation } from "$lib/tidy/types/direction.enum";
  import Extras from "../elements/controls/Extras.svelte";
  import { PointronEventEnum } from "$lib/local/types/pointronEvent.enum";
  import appearance from "$lib/tidy/stores/appearance.store";
  import SimpleDigitalClock from "../../clocks/SimpleDigitalClock.svelte";
  import FocusNotes from "../FocusNotes.svelte";
  export let isInline: boolean = false;
  let layout: number = 1;
  let isShowTimeLeftOnMobile: boolean = false;
  // if ($focusItemsStore.length < 1) {
  //   isInEditMode = true;
  // }
  function onFullScreenToggle(isShowFullScreen: boolean = true) {
    if (isShowFullScreen) {
      appStore.showFullScreenPlayer(PointronEventEnum.FULL_SCREEN_FOCUS);
    } else {
      appStore.hideFullScreenPlayer();
    }
  }
  $: isExtraLargeScreen = $view.landscapiness > 1.5 && $view.scale > 1.5;
</script>

<!-- {#snippet focusItemsHeading()}
<FocusItemsHeading {isInEditMode} on:click={onEditClicked} />
{/snippet} -->

{#if $view.isPortrait}
  <div
    on:touchstart|stopPropagation={startTouch}
    on:touchmove|stopPropagation={() =>
      moveTouch(
        event,
        undefined,
        undefined,
        appStore.hideFullScreenPlayer,
        undefined,
        undefined
      )}
    class="flex flex-col w-full h-full px-4 pt-4 pb-8 {$appearance.skin ===
    AppSkin.Glassy
      ? 'glassthick'
      : bgClass($appearance, 0)}"
  >
    {#if isInline}
      <div class="flex mb-10 justify-end w-full">
        <Button
          icon="full-screen"
          label="expand"
          size={Size.xs}
          on:click={() => onFullScreenToggle()}
        />
      </div>
      <!-- {:else} //not required since swipe down gesture is there if design needs it disable the togglefunction inside fullmobile header component
      <FullScreenMobileHeader /> -->
    {/if}
    <div class="flex flex-col gap-6 flex-grow w-full items-center">
      <IntervalBar />
      <div class="flex flex-col w-full items-center">
        <SessionTimeText size={Size.sm} />
        {#if $sessionStore.type != SessionType.COUNTUP && isShowTimeLeftOnMobile}
          <div class="w-full px-6">
            <TimeleftIndicator parentBackgroundIndex={0} />
          </div>
        {/if}
      </div>
      <div
        id="focusItems"
        on:touchstart|stopPropagation={startTouch}
        class="flex flex-col flex-grow gap-2 p-2 w-full h-64 overflow-auto styledscroll rounded-md {$appearance.skin ===
        AppSkin.Clean
          ? bgClass($appearance, 0)
          : ''}"
      >
        <FocusItemsHeading />
        <FocusItemList />
      </div>
    </div>
    {#if !isInline}
      <!-- <div class="flex w-full justify-center pt-2">
        <ControlBar size={Size.md} />
      </div> -->
      <div class="flex flex-col gap-12">
        <div class="flex w-full justify-center">
          <ControlBar size={Size.md} />
        </div>
        <div class="flex justify-center">
          <div class="w-5/6">
            <Extras isInFullScreen={!isInline} />
          </div>
        </div>
      </div>
    {/if}
  </div>
{:else if layout == 1}
  <div
    class="flex w-full h-full {$appearance.skin === AppSkin.Glassy
      ? 'glassthick'
      : ''}"
    aria-roledescription="zen mode"
  >
    <div
      class="flex flex-col items-center justify-center flex-grow {$appearance.skin ===
      AppSkin.Clean
        ? bgClass(
            $appearance,
            isInline && !$sessionStore.isQuickStartOn ? 0 : 1
          )
        : ''}"
    >
      <div class="flex flex-col justify-between w-full h-full py-6 px-10">
        <IntervalBar
          context={isInline
            ? IntervalBarContext.DEFAULT
            : IntervalBarContext.ZEN_ON_DESKTOP}
        />
        <div class="flex flex-col w-full items-center px-4 lg:px-8 xl:px-20">
          <SessionTimeText
            parentBackgroundIndex={isInline && !$sessionStore.isQuickStartOn
              ? 1
              : 2}
          />
          {#if $sessionStore.type != SessionType.COUNTUP}
            <TimeleftIndicator
              parentBackgroundIndex={isInline && !$sessionStore.isQuickStartOn
                ? 0
                : 1}
            />
          {/if}
        </div>
        <div class="flex flex-col gap-20">
          <div class="flex w-full justify-center">
            <ControlBar size={Size.xl} />
          </div>
          <div class="flex justify-center">
            <div class="w-3/4 xl:w-1/2">
              <Extras isInFullScreen={!isInline} />
            </div>
          </div>
        </div>
      </div>
    </div>
    {#if !isInline || !$sessionStore.isQuickStartOn}
      {#if isInline}
        <Divider orientation={Orientation.Vertical} />
      {/if}
      <div
        class="flex flex-col gap-4 pt-6 p-6 w-96 xl:w-1/3 2xl:1/4 {$appearance.skin ===
        AppSkin.Clean
          ? bgClass($appearance, 0)
          : ''}"
      >
        <FocusItemsHeading />
        <div class="overflow-y-auto h-full">
          <FocusItemList />
        </div>
      </div>
    {/if}
    {#if isExtraLargeScreen}
      <div class="w-1/4 p-4 bg-bgs2">
        <!-- <SimpleDigitalClock /> -->
        <FocusNotes />
      </div>
    {/if}
  </div>
{/if}
